/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Service acceptance cancel posting
*/

CREATE PROCEDURE [dbo].[SP_DLV_ServiceAcceptanceCancelPosting_20161007]
	
	@pid as BIGINT,
	@MODULE_ID as varchar(1),
	@FUNCTION_ID as varchar(5), -- '31303'
	@UserId as varchar(20)
AS
BEGIN
	DECLARE @T AS TABLE (PID BIGINT)
	DECLARE @na AS VARCHAR(50)
	DECLARE @step AS VARCHAR(50)
	DECLARE @isPostedError varchar(1) = 'N'
	DECLARE @log AS VARCHAR(MAX)
	DECLARE @steps AS VARCHAR(MAX)
	--DECLARE @po_period AS VARCHAR(6) = (SELECT CURRENT_IM_YEAR + '' + CURRENT_IM_PERIOD FROM TB_M_IM_PERIOD)
	DECLARE @SP_NAME as varchar(MAX) = 'SP_DLV_ServiceAcceptanceCancelPosting'
	DECLARE @SERVICE_DOC_NO as VARCHAR(11)
	DECLARE @LAST_SERV_DOC as VARCHAR(11)
	DECLARE @Y as VARCHAR(2)
	DECLARE @M as VARCHAR(2)
	DECLARE @D as VARCHAR(2)
	DECLARE @CURR_Y as VARCHAR(2)
	DECLARE @CURR_M as VARCHAR(2)
	DECLARE @CURR_D as VARCHAR(2)
	DECLARE @DIGIT as VARCHAR(4)
	DECLARE @SEQS as VARCHAR(4)
	DECLARE @ADDS AS VARCHAR(11)
	DECLARE @lastSeq INT;
	DECLARE @postSts as varchar(2)
	DECLARE @DlvSts as varchar(15)			
	
	INSERT INTO TB_T_DLV_SA_RAW(DELIVERY_NO, PROCESS_ID, ROUTE_CD, RATE, TRANSACTION_CD, PICKUP_DT, LP_CD, POSTING_DT, OK_FLAG, CREATED_BY, CREATED_DT)
	SELECT DISTINCT a.[DELIVERY_NO], @pid as PROCESS_ID, a.[ROUTE], a.[RATE], CASE WHEN b.[ROUTE_CD] IS NULL THEN '' ELSE '302' END, a.[PICKUP_DT], SUBSTRING(b.PO_NO,1,3), GETDATE() as POSTING_DT, CASE WHEN b.[ROUTE_CD] IS NULL THEN 'NG' ELSE 'OK' END AS OK_FLAG, @UserId, GETDATE()
	FROM TB_R_DELIVERY_CTL_H a
	LEFT JOIN TB_R_DLV_PO_ITEM b ON b.ROUTE_CD = a.ROUTE AND SUBSTRING(b.PO_NO, 1,3) = a.LP_CD
	WHERE a.[DELIVERY_NO] IN (SELECT DELIVERY_NO FROM TB_R_DELIVERY_CTL_H WHERE PROCESS_ID = @pid)
	
	UPDATE TB_R_DLV_QUEUE SET PROCESS_STATUS = 'QU2', PROCESS_START_DT = GETDATE() WHERE PROCESS_ID = @pid
	SET @log = 'Service acceptance cancel posting has been started by '+@SP_NAME;
	SET @step = 'StartSACancelPosting';
	INSERT INTO TB_R_LOG_D(PROCESS_ID, SEQUENCE_NUMBER, MESSAGE_ID, MESSAGE_TYPE, [MESSAGE], LOCATION, CREATED_BY, CREATED_DATE)
	SELECT @pid as PROCESS_ID, (SELECT TOP 1 SEQUENCE_NUMBER FROM TB_R_LOG_D WHERE PROCESS_ID = @pid ORDER BY SEQUENCE_NUMBER DESC) + 1 as SEQUENCE_NUMBER,'MPCS00002INF' as MESSAGE_ID, 'INF' as MESSAGE_TYPE, @log as [MESSAGE], 'SP_DLV_ServiceAcceptanceCancelPosting.'+@step, @UserId as CREATED_BY, GETDATE()	as CREATED_DATE

	select dlv_no, svc_no, lcd, rcd into #cancel_table from(SELECT a.DELIVERY_NO as dlv_no, (SELECT TOP 1 SERVICE_DOC_NO b FROM TB_R_DLV_SERVICE_DOC b WHERE b.REFF_NO = a.DELIVERY_NO ORDER BY b.SERVICE_DOC_NO DESC) as svc_no, a.LP_CD as lcd, a.ROUTE_CD as rcd FROM TB_T_DLV_SA_RAW a WHERE a.PROCESS_ID = @pid)tbl;

	--select* from #cancel_table;

	DECLARE @dlv_no varchar(13);
	DECLARE @svc_no varchar(11);
	DECLARE @lcd varchar(3);
	DECLARE @rcd varchar(4);
	DECLARE @j_status varchar(10) = '';
	DECLARE CANCELLATION_CURS CURSOR 
	FOR 
	SELECT dlv_no, svc_no, lcd, rcd
	FROM #cancel_table
	;

	OPEN CANCELLATION_CURS;
	FETCH NEXT FROM CANCELLATION_CURS INTO
	@dlv_no, @svc_no, @lcd, @rcd;

	WHILE @@FETCH_STATUS = 0  
	BEGIN  
		
		-- disini yg diambil per rownya
		--generating service doc no
		
		SET @LAST_SERV_DOC = (SELECT TOP 1 SERVICE_DOC_NO FROM TB_R_DLV_GR_IR ORDER BY SERVICE_DOC_NO DESC)
		SET @Y  = SUBSTRING(CAST(YEAR(GETDATE()) AS VARCHAR(4)), 3, 2)
		SET @M  = dbo.FN_VARMONTH(GETDATE())
		SET @D = dbo.FN_VARDAY(GETDATE())
		BEGIN
			SET @SERVICE_DOC_NO = @MODULE_ID+''+@Y;
			IF(@LAST_SERV_DOC<>'')
				BEGIN TRY
					SET @CURR_Y = (SELECT SUBSTRING(@LAST_SERV_DOC, 2,2))	
					SET @CURR_M = (SELECT SUBSTRING(@LAST_SERV_DOC, 4,2))
					SET @CURR_D = (SELECT SUBSTRING(@LAST_SERV_DOC, 6,2))
					SET @DIGIT ='0000'
					SET @SEQS = (SELECT SUBSTRING(@LAST_SERV_DOC, 8, LEN(@LAST_SERV_DOC)))
					SET @ADDS = (SELECT CAST(CAST(@SEQS as INT)+1 AS VARCHAR(11)))
					IF(SUBSTRING(@LAST_SERV_DOC,1,7) <> ('3'+@Y+''+@M+''+@D))
						SET @SERVICE_DOC_NO = @MODULE_ID+''+@Y+''+@M+''+@D+'0001';
					ELSE
						SET @SERVICE_DOC_NO = @MODULE_ID+''+@CURR_Y+''+@CURR_M+''+@CURR_D+''+(SELECT SUBSTRING(@DIGIT, 1, LEN(@DIGIT)-LEN(@ADDS))+@ADDS);
				END TRY
				BEGIN CATCH
					--DO NOTHING
				END CATCH
			ELSE
				BEGIN TRY
					SET @SERVICE_DOC_NO = @MODULE_ID+''+@Y+''+@M+''+@D+'0001';
				END TRY
				BEGIN CATCH
					--DO NOTHING
				END CATCH
		END
	
		--end of generating service doc no		
	SET @log = 'Update minus item for subtract current item by '+@SP_NAME;
	SET @step = 'SACancelPostingProcess';
	INSERT INTO TB_R_LOG_D(PROCESS_ID, SEQUENCE_NUMBER, MESSAGE_ID, MESSAGE_TYPE, [MESSAGE], LOCATION, CREATED_BY, CREATED_DATE)
	SELECT @pid as PROCESS_ID, (SELECT TOP 1 SEQUENCE_NUMBER FROM TB_R_LOG_D WHERE PROCESS_ID = @pid ORDER BY SEQUENCE_NUMBER DESC) + 1 as SEQUENCE_NUMBER,'MPCS00002INF' as MESSAGE_ID, 'INF' as MESSAGE_TYPE, @log as [MESSAGE], 'SP_DLV_ServiceAcceptanceCancelPosting.'+@step, @UserId as CREATED_BY, GETDATE()	as CREATED_DATE
		
		UPDATE TB_R_DLV_SERVICE_DOC SET SA_CANCEL_REFF_NO = @SERVICE_DOC_NO, SA_CANCEL_REFF_YEAR = CAST(YEAR(DATEADD(MM,-3, GETDATE())) as VARCHAR(4)), CHANGED_BY = @UserId, CHANGED_DT = GETDATE() WHERE SERVICE_DOC_NO = @svc_no AND REFF_NO = @dlv_no
		
		INSERT INTO TB_R_DLV_SERVICE_DOC (SERVICE_DOC_NO, SERVICE_DOC_YEAR, PROCESS_ID, DOC_DT,PO_NO,PROD_MONTH,LP_CD, ROUTE_CD, TRANSACTION_QTY, TRANSACTION_CD, TRANSACTION_SIGN, TRANSACTION_VALUE, TRANSACTION_CURR, REFF_NO, SYSTEM_SOURCE, CREATED_BY, CREATED_DT)
		SELECT TOP 1 @SERVICE_DOC_NO, SERVICE_DOC_YEAR, @pid, DOC_DT,PO_NO,PROD_MONTH,LP_CD, ROUTE_CD, TRANSACTION_QTY, (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE FUNCTION_ID = '31303' AND SYSTEM_CD = 'TRANS_CD_SA_CANCEL_POSTING'), '-', TRANSACTION_VALUE, TRANSACTION_CURR, @dlv_no, SYSTEM_SOURCE, @UserId, GETDATE() FROM TB_R_DLV_SERVICE_DOC WHERE REFF_NO = @dlv_no ORDER BY SERVICE_DOC_NO DESC
	
			select pono, pin, sdn, sdy, ino, rn into #LoopRaw3 from(
				SELECT PO_NO as pono, PO_ITEM_NO as pin, SERVICE_DOC_NO as sdn, SERVICE_DOC_YEAR as sdy, ITEM_NO as ino, REFF_NO as rn FROM TB_R_DLV_GR_IR WHERE REFF_NO = @dlv_no
			)tbl2;

			DECLARE 
				@pono as varchar(11),
				@pin as int,
				@sdn as varchar(11),
				@sdy as varchar(4),
				@ino as int,
				@rn as varchar(13)
				
			DECLARE BTMP_CURS3 CURSOR 
			FOR 
			SELECT pono, pin, sdn, sdy, ino, rn FROM #LoopRaw3;
			OPEN BTMP_CURS3;
			FETCH NEXT FROM BTMP_CURS3 INTO @pono, @Pin, @sdn, @sdy, @ino, @rn;
			WHILE @@FETCH_STATUS = 0  
			BEGIN  
			
				SET @log = 'Insert new record to DLV_GR_IR and Update the old one by '+@SP_NAME;
				SET @step = 'SACancelPostingProcess';
				
				BEGIN TRY
					INSERT INTO TB_R_LOG_D(PROCESS_ID, SEQUENCE_NUMBER, MESSAGE_ID, MESSAGE_TYPE, [MESSAGE], LOCATION, CREATED_BY, CREATED_DATE)
					SELECT @pid as PROCESS_ID, (SELECT TOP 1 SEQUENCE_NUMBER FROM TB_R_LOG_D WHERE PROCESS_ID = @pid ORDER BY SEQUENCE_NUMBER DESC) + 1 as SEQUENCE_NUMBER,'MPCS00002INF' as MESSAGE_ID, 'INF' as MESSAGE_TYPE, @log as [MESSAGE], 'SP_DLV_ServiceAcceptanceCancelPosting.'+@step, @UserId as CREATED_BY, GETDATE()	as CREATED_DATE
					
					INSERT INTO TB_R_DLV_GR_IR(PO_NO, PO_ITEM_NO, SERVICE_DOC_NO, SERVICE_DOC_YEAR, ITEM_NO, DOC_DT, GR_IR_AMT, LP_CD, COMP_PRICE_CD, ACCRUAL_POSTING_FLAG, REFF_NO, CONDITION_CATEGORY, PO_DETAIL_PRICE, TAX_CD, PLUS_MINUS_FLAG, ITEM_CURR, CANCEL_STS, CREATED_BY, CREATED_DT)
					SELECT @pono, @pin, @SERVICE_DOC_NO, CAST(YEAR(DATEADD(MM,-3, GETDATE())) as VARCHAR(4)), @ino, GETDATE(), GR_IR_AMT, LP_CD, COMP_PRICE_CD, ACCRUAL_POSTING_FLAG, REFF_NO, CONDITION_CATEGORY, PO_DETAIL_PRICE, TAX_CD, PLUS_MINUS_FLAG, 'IDR', '1', @UserId, GETDATE() FROM TB_R_DLV_GR_IR WHERE PO_NO = @pono AND PO_ITEM_NO = @pin AND SERVICE_DOC_NO = @sdn AND SERVICE_DOC_YEAR = @sdy AND ITEM_NO = @ino AND REFF_NO = @rn
					
					UPDATE TB_R_DLV_GR_IR SET  STATUS_CD = '', SA_CANCEL_REFF_YEAR = CAST(YEAR(DATEADD(MM,-3, GETDATE())) as VARCHAR(4)), CANCEL_STS = '1', SA_CANCEL_REFF_NO = @SERVICE_DOC_NO WHERE PO_NO = @pono AND PO_ITEM_NO = @pin AND SERVICE_DOC_NO = @sdn AND SERVICE_DOC_YEAR = @sdy AND ITEM_NO = @ino AND REFF_NO = @rn
				END TRY
				BEGIN CATCH
					UPDATE TB_R_DLV_QUEUE set PROCESS_STATUS = 'QU4', PROCESS_END_DT = GETDATE(), CHANGED_BY = @UserId, CHANGED_DT = GETDATE() WHERE PROCESS_ID = @pid				
				END CATCH
				
				
				FETCH NEXT FROM BTMP_CURS3 INTO @pono, @Pin, @sdn, @sdy, @ino, @rn
			END;
			CLOSE BTMP_CURS3;
			DEALLOCATE BTMP_CURS3;
			drop table #LoopRaw3;
		
		
		SET @log = 'Update cancel flag to delivery header by '+@SP_NAME;
		SET @step = 'SACancelPostingProcess';
		INSERT INTO TB_R_LOG_D(PROCESS_ID, SEQUENCE_NUMBER, MESSAGE_ID, MESSAGE_TYPE, [MESSAGE], LOCATION, CREATED_BY, CREATED_DATE)
		SELECT @pid as PROCESS_ID, (SELECT TOP 1 SEQUENCE_NUMBER FROM TB_R_LOG_D WHERE PROCESS_ID = @pid ORDER BY SEQUENCE_NUMBER DESC) + 1 as SEQUENCE_NUMBER,'MPCS00002INF' as MESSAGE_ID, 'INF' as MESSAGE_TYPE, @log as [MESSAGE], 'SP_DLV_ServiceAcceptanceCancelPosting.'+@step, @UserId as CREATED_BY, GETDATE()	as CREATED_DATE
		
		
		
		UPDATE TB_R_DELIVERY_CTL_H SET SA_CANCEL_REFF_NO = @SERVICE_DOC_NO, SA_CANCEL_REFF_YEAR = CAST(YEAR(DATEADD(MM,-3, GETDATE())) as VARCHAR(4)) WHERE DELIVERY_NO = @dlv_no
		
		UPDATE TB_R_DLV_PO_ITEM SET OPEN_QTY = [OPEN_QTY] + 1, [SA_QTY] = [SA_QTY] - 1 WHERE [PO_NO] = (SELECT PO_NO FROM TB_R_DLV_SERVICE_DOC WHERE REFF_NO = @dlv_no and SERVICE_DOC_NO = @SERVICE_DOC_NO) AND [ROUTE_CD] = @rcd
		
		DECLARE @DOC_NO as varchar(max) = (SELECT DOC_NO FROM TB_R_DLV_FI_TRANS_H WHERE DOC_HEADER_TXT = @dlv_no)
		--DELETE FROM TB_R_DLV_FI_TRANS_H WHERE DOC_NO = @DOC_NO
		--DELETE FROM TB_R_DLV_FI_TRANS_D WHERE DOC_NO = @DOC_NO
		--DELETE FROM TB_R_DLV_FI_JOURNAL WHERE DOC_NO = @DOC_NO
		EXEC SP_DLV_POSTING_GR @UserId, @pid, @dlv_no, 'TRANS_CD_SA_CANCEL_POSTING', @j_status OUTPUT
		

	FETCH NEXT FROM CANCELLATION_CURS INTO 
		@dlv_no, @svc_no, @lcd, @rcd
	END;
	CLOSE CANCELLATION_CURS;
	DEALLOCATE CANCELLATION_CURS;

	drop table #cancel_table;
	
	--IF @isPostedError = 'Y'
	--	UPDATE TB_R_DLV_QUEUE set PROCESS_STATUS = 'QU4', PROCESS_END_DT = GETDATE() WHERE PROCESS_ID = @pid			
	--ELSE
	--	UPDATE TB_R_DLV_QUEUE set PROCESS_STATUS = 'QU3', PROCESS_END_DT = GETDATE() WHERE PROCESS_ID = @pid
	UPDATE TB_R_DLV_QUEUE set PROCESS_STATUS = 'QU3', PROCESS_END_DT = GETDATE(), CHANGED_BY = @UserId, CHANGED_DT = GETDATE() WHERE PROCESS_ID = @pid
	DELETE FROM TB_T_DLV_SA_RAW WHERE PROCESS_ID = @pid			
	SET @log = 'Cancel posting service acceptance has been finished '+@SP_NAME;
	SET @step = 'FinishSACancelPosting';
	INSERT INTO TB_R_LOG_D(PROCESS_ID, SEQUENCE_NUMBER, MESSAGE_ID, MESSAGE_TYPE, [MESSAGE], LOCATION, CREATED_BY, CREATED_DATE)
	SELECT @pid as PROCESS_ID, (SELECT TOP 1 SEQUENCE_NUMBER FROM TB_R_LOG_D WHERE PROCESS_ID = @pid ORDER BY SEQUENCE_NUMBER DESC) + 1 as SEQUENCE_NUMBER,'MPCS00002INF' as MESSAGE_ID, 'INF' as MESSAGE_TYPE, @log as [MESSAGE], 'SP_DLV_ServiceAcceptanceCancelPosting.'+@step, @UserId as CREATED_BY, GETDATE()	as CREATED_DATE
END

